package pt.digitalis.utils.common;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;

/**
 * @author Galaio da Silva <a href="mailto:jgalaio@digitalis.pt">jgalaio@digitalis.pt</a><br/>
 * @created 17 de Fev de 2011
 */
public class LocaleUtils {

    /** the locale list */
    private static List<DIFLocale> localeList = null;

    /** The locale map */
    private static HashMap<String, String> localeMap = null;

    // private static HashMap<String,String> localMap

    /**
     * Get the locale codes with corresponding contry/region language
     * 
     * @return the locale list
     */
    public static List<DIFLocale> getLocaleList()
    {
        if (localeList == null)
        {
            localeList = new ArrayList<DIFLocale>();
            Locale list[] = SimpleDateFormat.getAvailableLocales();

            for (Locale locale: list)
            {
                DIFLocale difLocale = new DIFLocale();
                difLocale.setCode(locale.toString());
                difLocale.setCountry(locale.getCountry());
                difLocale.setFormatedName(locale.getDisplayLanguage()
                        + (!"".equals(locale.getDisplayCountry()) ? " (" + locale.getDisplayCountry() + ")" : ""));
                difLocale.setDisplayName(locale.getDisplayLanguage());
                localeList.add(difLocale);
            }
        }
        return localeList;
    }

    /**
     * @return the map
     */
    public static HashMap<String, String> getLocalList()
    {
        if (localeMap == null)
        {
            localeMap = new HashMap<String, String>();
            Locale list[] = SimpleDateFormat.getAvailableLocales();
            for (Locale locale: list)
            {
                localeMap.put(locale.toString(), locale.getDisplayLanguage()
                        + (!"".equals(locale.getDisplayCountry()) ? " (" + locale.getDisplayCountry() + ")" : ""));
            }
        }
        return localeMap;

    }
}
